package eu.clarin.cmdi.mdservice.proxy;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

import eu.clarin.cmdi.mdservice.action.WorkspaceRepositoryAction;
import eu.clarin.cmdi.mdservice.internal.CQLParseException;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Diagnostics;
import eu.clarin.cmdi.mdservice.model.FCSRepositories;
import eu.clarin.cmdi.mdservice.model.Query;
import eu.clarin.cmdi.mdservice.model.Repositories;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;


public class FCSProxy extends SRUProxy
{

	private static final long serialVersionUID = 1L;
	
	private String proxy_key = "fcs";
	private static Logger log = Logger.getLogger("FCSProxy");		 
	 
	public FCSProxy(Query q) {
		super(q);
		// TODO Auto-generated constructor stub
	}
	 
	@Override
	public String getProxyKey() {				
			return proxy_key;		
	}
	
	@Override
	public void checkParams() {
		// required Params
		// check and set defaults
		if (getParam("operation").equals("")) {
			//getSourceAction().setParam("operation","searchRetrieve");
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "operation");
		}
		/*
		if (getParam("query").equals("") && getParam("operation").equals("searchRetrieve")) {
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "query");
		}
		if (getParam("scanClause").equals("") && getParam("operation").equals("scan")) {
			getSourceAction().getDiagnostics().Add(Diagnostic.MANDATORY_NOTSUPPLIED, "scan");
		}
*/

		
	}
	
	
	/**
	 * Provides the repostory-URL specific to given target repository or registry 
	 * @return
	 * @throws MalformedURLException
	 */	
	public URL getScanRepositoryURL() throws MalformedURLException {		
		String urlstring = Repositories.getRepositories().getRepositoryPath(getSourceAction().getRepository()) + "?operation=" + getParam("operation") + "&scanClause=" + getParam("scanClause") ;
		if (FCSRepositories.getFCSRepositories().getFCSMapping(getParam("x-context")) != null){
			urlstring = urlstring + "&x-context=" + getParam("x-context");
		}
		URL url = new URL(urlstring);
		
		return url;
	}
	/**
	 * the operations scan, explain 
	 * or in getSOurceStream??
	 */	
	
	@Override
	public URL getTargetRequest() throws IOException, CQLParseException {
		
		URL targetURL;
		if (getSourceAction().getParam("operation").equals("scan") && !getSourceAction().getParam("x-context").equals("")) {// && getSourceAction().getParam("scanClause").equals("fcs.resource")){
			targetURL = getScanRepositoryURL();
		} else {
			targetURL =  super.getTargetRequest();
		}
		
		log.debug("getTargetRequest().targetURL:" + targetURL);
	    return targetURL;
		
	}
	
}